<template id="offer">
    <v-ons-page class="main-page">
        <v-ons-toolbar>
            <div class="center text-center">
                <img src="/img/handly.svg" class="mr-2" :alt="title">
                <h1>{{ title }}</h1>
            </div>
            <div class="right position-absolute">
                <v-ons-toolbar-button @click="toggleMenu">
                    <v-ons-icon icon="ion-ios-menu, material: md-menu"></v-ons-icon>
                </v-ons-toolbar-button>
            </div>
        </v-ons-toolbar>

        <v-ons-progress-bar :value="progress"></v-ons-progress-bar>

        <div class="p-3 my-3">
            <v-ons-list>
                <v-ons-list-item>
                    <div class="center">
                        <v-ons-input placeholder="Аты-жөніңіз" float v-model="form.name" class="w-100"></v-ons-input>
                    </div>
                </v-ons-list-item>
                <v-ons-list-item>
                    <div class="center">
                        <v-ons-input placeholder="Электрондық поштаңыз" float type="email" v-model="form.email" class="w-100"></v-ons-input>
                    </div>
                </v-ons-list-item>
                <v-ons-list-item>
                    <div class="center">
                        <v-ons-input placeholder="Пікіріңіз" float v-model="form.text" class="w-100"></v-ons-input>
                    </div>
                </v-ons-list-item>
            </v-ons-list>
            <v-ons-button modifier="large" class="my-3 btn-primary" :disabled="!(form.name && form.email && form.text)" @click="sendOffer">Жіберу</v-ons-button>
        </div>
    </v-ons-page>
</template>


<script>
    import {_} from 'underscore'
    export default {
        props: ['toggleMenu'],
        data() {
            return {
                title: document.title,
                progress: 0,
                progressBarFinished: false,
                form: {
                    name: '',
                    email: '',
                    text: ''
                }
            }
        },
        mounted() {
            setInterval(() => {
                if (this.progress >= 100) {
                    return;
                } else if (this.progress > 90) {
                    this.progress = this.progress + 0.2
                } else if (this.progress > 80) {
                    this.progress = this.progress + 0.5
                } else {
                    this.progress++;
                }
            }, 40)
        },
        methods: {
            isAndroid() {
                return this.$ons.platform.isAndroid();
            },
            finishProgress() {
                this.progress = 100;
            },
            sendOffer() {
                axios.post(`/api/offer`, this.form)
                    .then(response => {
                        this.$ons.notification.alert('Пікіріңіз жіберілді.')
                        this.form = {
                            name: '',
                            email: '',
                            text: ''
                        }
                    })
                    .catch(error => {
                        if(error.response.status === 422) {
                            this.$ons.notification.alert(_.first(_.flatten(_.values(error.response.data.errors))))
                        } else {
                            console.log('Проверьте интернет-подключение или повторите попытку позже!')
                            this.$ons.notification.alert('Проверьте интернет-подключение или повторите попытку позже!')
                        }
                    })
            }
        }
    }
</script>